<template>
	<div>
    <div class="padding">
      <h3>Место нахождения работодателя</h3>
    </div>
    <hr/>
    <div class="padding">
      <div class="row">
        <div class="column">
          <label for="region">Район, населенный пункт, улица</label>
          <input type="text"
                 id="region"
                 ref="workAddress"
                 name="regionWork"
                 v-model="region"
                 @input="getRegion"
                 @keyup.esc="checkStreet"
                 @blur="checkStreet"
                 :class="getValidateClass('regionWork')"
                 @keydown.down="moveDownRegion"
                 @keydown.up="moveUpRegion"
                 v-validate="'required|min:3|max:250'"
                 @keydown.enter.prevent="checkRegion(selectedItem); isOpenRegion = false"
          >
          <ul class="options-list" v-show="isOpenRegion">
            <li v-for="(item, index) in suggestions"
                @mousedown="checkRegion(index)"
                @mouseenter="selectedItem = index"
                :class="{'highlighted': index === selectedItem}"
            >{{item.value}}</li>
          </ul>
          <validate-message
              v-show="vErrors.has('regionWork')"
            >{{ vErrors.first('regionWork') }}
            </validate-message>
        </div>
      </div>

      <div class="warning-yellow-block">
        <ul class="without-marker">
          <li><strong>1.</strong> Начните вводить адрес и выберите из списка.</li>
          <li><strong>2.</strong> В случае, если в вашем населенном пункте (деревне, селе) улица существует, но вы преднамеренно не указали её, по заявке будет отказ!</li>
        </ul>
      </div>

      <div class="row">
          <div class="columns two-third">
            <label for="house">Дом</label>
            <input type="text"
                   id="house"
                   name="houseWork"
                   v-model="house"
                   @input="getHouse"
                   :class="getValidateClass('houseWork')"
                   @keyup.esc="fixHouse"
                   @blur="fixHouse"
                   @keydown.down="moveDownHouse"
                   @keydown.up="moveUpHouse"
                   v-validate="'required'"
                   @keydown.enter.prevent="checkRegion(selectedItem); isOpenHouse = false"
            >
            <ul class="options-list" v-show="isOpenHouse">
              <li v-for="(item, index) in houses"
                  @mousedown="checkHouse(index)"
                  @mouseenter="selectedItem = index"
                  :class="{'highlighted': index === selectedItem}"
              >{{item}}</li>
            </ul>
            <validate-message
              v-show="vErrors.has('houseWork')"
            >{{ vErrors.first('houseWork') }}
            </validate-message>
          </div>

          <div class="columns two-third">
            <label for="index">Индекс</label>
            <input type="text"
                   id="index"
                   name="рабочий индекс"
                   :class="getValidateClass('рабочий индекс')"
                   @input="changeIndex"
                   v-model="index"
                   v-mask="'######'"
                   v-validate="'required|addressIndex'"
            >

            <validate-message
              v-show="vErrors.has('рабочий индекс')"
            >{{ vErrors.first('рабочий индекс') }}
            </validate-message>
          </div>

          <div class="columns two-third">
            <label for="housing">Корпус</label>
            <input type="text"
                   id="housing"
                   name="housing"
                   v-model="housing"
                   @input="changeHousing"
            >
          </div>

          <div class="columns two-third">
            <label for="building">Строение</label>
            <input type="text"
                   id="building"
                   name="building"
                   v-model="building"
                   @input="changeBuilding"
            >
          </div>

          <div class="columns two-third">
            <label for="flat">Офис</label>
            <input type="text"
                   id="flat"
                   name="flat"
                   v-mask="'###'"
                   v-model="this.$store.state.authorizedUser.workAddress.flat"
                   @input="changeFlat"
            >
          </div>
      </div>
      <div class="row" v-if="isActive">
        <div class="column checkbox">
          <input type="checkbox"
                 name="doNotHaveStreet"
                 id="doNotHaveStreet"
                 v-model="this.$store.state.authorizedUser.workAddress.doNotHaveStreet"
                 @change="updatedDataOfUser"
          >
          <label for="doNotHaveStreet"> <span></span>Я подтверждаю, что по моему адресу регистрации улица отсутствует.</label>
        </div>
      </div>
    </div>
	</div>
</template>

<script>
  import ChangeDataInProfile from '@/mixins/Profile/ChangeDataInProfile'
  import UserErrorText from '@/mixins/User/UserErrorTextMixin'
  import GetValidateClass from '@/mixins/Validation/GetValidateClassMixin'
  import { REQUIRED_FIELD, MIN_LENGHT, MAX_LENGHT } from '@/components/Validators/CustomVeeValidateMessage'
  import {suggestAddress} from '@/utils/api'

  export default {
    name: 'work-address',
    mixins: [
      UserErrorText,
      ChangeDataInProfile,
      GetValidateClass
    ],
    data () {
      return {
        isOpenRegion: false,
        isOpenHouse: false,
        isActive: false,
        selectedItem: 0,
        //
        region_with_type: '',
        city_type: '',
        area_with_type: '',
        settlement_with_type: '',
        street_type: '',
        //
        city: '',
        settlement: '',
        region: '',
        street: '',
        house: '',
        index: '',
        housing: '',
        building: '',
        suggestions: [],
        houses: [],
        currentData: null,
        //
        value: null,
        region_fias_id: null,
        area_fias_id: null,
        city_fias_id: null,
        settlement_fias_id: null,
        street_fias_id: null,
        house_fias_id: null,
        cityLocation: 'г.',
        settlementLocation: 'н/п',
        streetLocation: 'ул.'
      }
    },
    created () {
      // String.prototype.capitalize = function () {
      //   return this.charAt(0).toUpperCase() + this.slice(1)
      // }
      this.city = this.$store.state.authorizedUser.workAddress.city
      this.settlement = this.$store.state.authorizedUser.workAddress.settlement
      this.street = this.$store.state.authorizedUser.workAddress.street
      // this.region = [this.cityLocation + this.city !== null ? this.cityLocation + ' ' + this.city.capitalize() + ',' : '',
      //   this.settlement !== null ? this.settlementLocation + ' ' + this.settlement.capitalize() + ',' : '',
      //   this.street !== null ? this.streetLocation + ' ' + this.street.capitalize() : ''
      // ].join(' ')
      this.region = this.$store.state.authorizedUser.workAddressFiases.value
      this.house = this.$store.state.authorizedUser.workAddress.house
      this.index = this.$store.state.authorizedUser.workAddress.postalCode
      this.housing = this.$store.state.authorizedUser.workAddress.housing
      this.building = this.$store.state.authorizedUser.workAddress.building
    },
    methods: {
      getRegion () {
        this.isOpenRegion = true
        suggestAddress(this.region)
          .then((res) => {
            this.suggestions = res.data.suggestions
          })
          .catch((err) => {
            console.log('err', err)
          })
      },
      checkRegion (i) {
        // заполнение поля район, населенный пункт, улица
        this.region =
          (this.suggestions[i].data.region_with_type && this.suggestions[i].data.region !== 'Санкт-Петербург' && this.suggestions[i].data.region !== 'Москва' ? this.suggestions[i].data.region_with_type + ', ' : '') + // Название области
          (this.suggestions[i].data.city_type ? this.suggestions[i].data.city_type + '. ' : '') + // тип (город, деревня, село)
          (this.suggestions[i].data.city ? this.suggestions[i].data.city : '') + // название города
          (this.suggestions[i].data.area_with_type ? ' ' + this.suggestions[i].data.area_with_type : '') + // район, если такой есть
          (this.suggestions[i].data.settlement_with_type ? ', ' + this.suggestions[i].data.settlement_with_type : '') + // район, если такой есть
          (this.suggestions[i].data.street_type ? ', ' + this.suggestions[i].data.street_type + '. ' : '') + // тип (улица, б-р, п-к)
          (this.suggestions[i].data.street ? this.suggestions[i].data.street : '') // название улицы
        this.city = this.suggestions[i].data.city
        this.settlement = this.suggestions[i].data.settlement
        this.street = this.suggestions[i].data.street
        this.region_with_type = this.suggestions[i].data.region_with_type
        this.city_type = this.suggestions[i].data.city_type
        this.area_with_type = this.suggestions[i].data.area_with_type
        this.settlement_with_type = this.suggestions[i].data.settlement_with_type
        this.street_type = this.suggestions[i].data.street_type
        // автоматическое заполнение остальных полей
        this.house = (this.suggestions[i].data.house ? this.suggestions[i].data.house : '') // выведит в поле дом номер дома
        this.index = (this.suggestions[i].data.postal_code ? this.suggestions[i].data.postal_code : '') // выведит в поле индекс
        // заполнение полей корпус и строение
        if (this.suggestions[i].data.block_type === 'к') {
          const buildingIndex = this.suggestions[i].data.block.indexOf(' стр ')
          if (buildingIndex > -1) {
            this.housing = (this.suggestions[i].data.block ? this.suggestions[i].data.block.substring(0, buildingIndex) : '')
            this.building = (this.suggestions[i].data.block ? this.suggestions[i].data.block.substring(buildingIndex + 5) : '')
          } else {
            this.housing = (this.suggestions[i].data.block ? this.suggestions[i].data.block : '')
          }
        } else if (this.suggestions[i].data.block_type === 'стр' || this.suggestions[i].data.block_type === 'сооружение') {
          this.building = (this.suggestions[i].data.block ? this.suggestions[i].data.block : '')
        }
        if (this.suggestions[i].data.block_type === null) {
          this.housing = ''
          this.building = ''
        }
        this.currentData = {...this.currentData, ...this.suggestions[this.selectedItem]}
      },
      getHouse () {
        this.isOpenHouse = true
        suggestAddress(this.region + ', д' + this.house)
          .then((res) => {
            this.suggestions = res.data.suggestions
            this.houses = res.data.suggestions.reduce((acc, item) => {
              if (!item.data.house) {
                return acc
              }
              return [...acc, `${item.data.house_type || ''} ${item.data.house || ''} ${item.data.block_type || ''} ${item.data.block || ''}`]
            }, [])
          })
          .catch((err) => {
            console.log('err:', err)
          })
      },
      checkHouse (i) {
        this.house = this.suggestions[i].data.house
        this.index = (this.suggestions[i].data.postal_code ? this.suggestions[i].data.postal_code : '') // выведит в поле индекс
        if (this.suggestions[i].data.block_type === 'к') {
          const buildingIndex = this.suggestions[i].data.block.indexOf(' стр ')
          if (buildingIndex > -1) {
            this.housing = (this.suggestions[i].data.block ? this.suggestions[i].data.block.substring(0, buildingIndex) : '')
            this.building = (this.suggestions[i].data.block ? this.suggestions[i].data.block.substring(buildingIndex + 5) : '')
          } else {
            this.housing = (this.suggestions[i].data.block ? this.suggestions[i].data.block : '')
          }
        } else if (this.suggestions[i].data.block_type === 'стр' || this.suggestions[i].data.block_type === 'сооружение') {
          this.building = (this.suggestions[i].data.block ? this.suggestions[i].data.block : '')
        }
        if (this.suggestions[i].data.block_type === null) {
          this.housing = ''
          this.building = ''
        }
        this.currentData = {...this.currentData, ...this.suggestions[this.selectedItem]}
        this.updatedDataOfUser(this.$store.state.authorizedUser)
      },
      moveDownRegion () {
        if (!this.isOpenRegion && !this.isOpenHouse) {
          return false
        }
        this.selectedItem = (this.selectedItem + 1) % this.suggestions.length
        this.region = this.suggestions.length > 1 ? (this.suggestions[this.selectedItem].value) : null
      },
      moveUpRegion () {
        if (!this.isOpenRegion && !this.isOpenHouse) {
          return
        }
        this.selectedItem = this.selectedItem - 1 < 0 ? this.suggestions.length - 1 : this.selectedItem - 1
        this.region = this.suggestions.length > 1 ? (this.suggestions[this.selectedItem].value) : null
      },
      moveDownHouse () {
        if (!this.isOpenRegion && !this.isOpenHouse) {
          return
        }
        this.selectedItem = (this.selectedItem + 1) % this.suggestions.length
        this.house = this.suggestions.length > 1 && this.suggestions[this.selectedItem].data.house !== undefined ? (this.suggestions[this.selectedItem].data.house) : null
      },
      moveUpHouse () {
        if (!this.isOpenRegion && !this.isOpenHouse) {
          return
        }
        this.selectedItem = this.selectedItem - 1 < 0 ? this.suggestions.length - 1 : this.selectedItem - 1
        this.house = this.suggestions.length > 1 ? (this.suggestions[this.selectedItem].data.house) : null
      },
      checkStreet () {
        this.isOpenRegion = false
        if (this.street === '' || this.street === null) {
          this.isActive = true
        } else {
          this.isActive = false
          this.$store.state.authorizedUser.workAddress.doNotHaveStreet = false
          this.updatedDataOfUser(this.$store.state.authorizedUser)
        }
      },
      fixHouse (e) {
        this.isOpenHouse = false
        this.$store.state.authorizedUser.workAddress.house = e.target.value
        this.updatedDataOfUser(this.$store.state.authorizedUser)
      },
      changeIndex (e) {
        this.$store.state.authorizedUser.workAddress.postalCode = e.target.value
        this.updatedDataOfUser(this.$store.state.authorizedUser)
      },
      changeHousing (e) {
        e.target.value === '' ? this.$store.state.authorizedUser.workAddress.housing = null : this.$store.state.authorizedUser.workAddress.housing = e.target.value
        this.updatedDataOfUser(this.$store.state.authorizedUser)
      },
      changeBuilding (e) {
        e.target.value === '' ? this.$store.state.authorizedUser.workAddress.building = null : this.$store.state.authorizedUser.workAddress.building = e.target.value
        this.updatedDataOfUser(this.$store.state.authorizedUser)
      },
      changeFlat (e) {
        e.target.value === '' ? this.$store.state.authorizedUser.workAddress.flat = null : this.$store.state.authorizedUser.workAddress.flat = e.target.value
        this.updatedDataOfUser(this.$store.state.authorizedUser)
      }
    },
    watch: {
      currentData () {
        try {
          let address = this.$store.state.authorizedUser.workAddress
          let info = this.currentData.data
          address.postalCode = info.postal_code
          address.region = info.region_kladr_id
          address.city = (info.city === null) ? info.settlement : info.city
          address.settlement = info.settlement
          address.street = info.street
          address.geoLat = info.geo_lat
          address.geoLon = info.geo_lon
          address.house = info.house
          if (this.currentData.data.block_type === 'к') {
            const buildingIndex = this.currentData.data.block.indexOf(' стр ')
            if (buildingIndex > -1) {
              address.housing = this.currentData.data.block.substring(0, buildingIndex)
              address.building = this.currentData.data.block.substring(buildingIndex + 5)
            } else {
              address.housing = this.currentData.data.block
            }
          } else if (this.currentData.data.block_type === 'стр' || this.currentData.data.block_type === 'сооружение') {
            address.building = this.currentData.data.block
          }
          let workAddressFiases = this.$store.state.authorizedUser.workAddressFiases
          workAddressFiases.value = this.currentData.value
          workAddressFiases.region_fias_id = info.region_fias_id
          workAddressFiases.area_fias_id = info.area_fias_id
          workAddressFiases.city_fias_id = info.city_fias_id
          workAddressFiases.settlement_fias_id = info.settlement_fias_id
          workAddressFiases.street_fias_id = info.street_fias_id
          workAddressFiases.house_fias_id = info.house_fias_id
          this.updatedDataOfUser(this.$store.state.authorizedUser)
        } catch (e) {
          console.log(e)
          return false
        }
      }
    },
    mounted () {
      this.$validator.localize(REQUIRED_FIELD)
      this.$validator.localize(MIN_LENGHT)
      this.$validator.localize(MAX_LENGHT)
    }
  }
</script>

<style scoped>
  .options-list {
    display: flex;
    flex-direction: column;
    margin-top: -40px;
    border: 1px solid #dbdbdb;
    border-radius: 0 0 3px 3px;
    position: relative;
    width: 100%;
    overflow: hidden;
    list-style: none;
    z-index: 6;
  }
  .options-list li {
    width: 100%;
    flex-wrap: wrap;
    background: white;
    margin: 0;
    border-bottom: 1px solid #eee;
    color: #363636;
    padding: 7px;
    cursor: pointer;
  }
  li.highlighted {
    background: #f8f8f8;
  }
  .without-marker li {
    border-bottom: none;
    background: none;
  }
</style>
